//+------------------------------------------------------------------+
//|                                           Schaff Trend Cycle.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_minimum -1.1
#property indicator_maximum +1.1
#property indicator_width1  2

//
//
//
//
//

extern int STCPeriod    = 10;
extern int FastMAPeriod = 23;
extern int SlowMAPeriod = 50;

double stcSlope[];
double stcBuffer[];
double macdBuffer[];
double fastKBuffer[];
double fastDBuffer[];
double fastKKBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,stcSlope);
   SetIndexBuffer(1,stcBuffer);
   SetIndexBuffer(2,macdBuffer);
   SetIndexBuffer(3,fastKBuffer);
   SetIndexBuffer(4,fastDBuffer);
   SetIndexBuffer(5,fastKKBuffer);
      IndicatorShortName("Schaff Trend Cycle binary ("+STCPeriod+","+FastMAPeriod+","+SlowMAPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      for(int i = limit; i >= 0; i--)
      {
         macdBuffer[i] = iMA(NULL,0,FastMAPeriod,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);

            double lowMacd  = minValue(macdBuffer,i);
            double highMacd = maxValue(macdBuffer,i)-lowMacd;
               if (highMacd > 0)
                     fastKBuffer[i] = 100*((macdBuffer[i]-lowMacd)/highMacd);
               else  fastKBuffer[i] = fastKBuffer[i+1];
                     fastDBuffer[i] = fastDBuffer[i+1]+0.5*(fastKBuffer[i]-fastDBuffer[i+1]);
               
            double lowStoch  = minValue(fastDBuffer,i);
            double highStoch = maxValue(fastDBuffer,i)-lowStoch;
               if (highStoch > 0)
                     fastKKBuffer[i] = 100*((fastDBuffer[i]-lowStoch)/highStoch);
               else  fastKKBuffer[i] = fastKKBuffer[i+1];
                     stcBuffer[i]    = stcBuffer[i+1]+0.5*(fastKKBuffer[i]-stcBuffer[i+1]);
                  
         //
         //
         //
         //
         //
         
         stcSlope[i] = stcSlope[i+1];
            if (stcBuffer[i]>stcBuffer[i+1]) stcSlope[i] =  1;
            if (stcBuffer[i]<stcBuffer[i+1]) stcSlope[i] = -1;
      }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double minValue(double& array[],int shift)
{
   double minValue = array[shift];
            for (int i=1; i<STCPeriod; i++) minValue = MathMin(minValue,array[shift+i]);
   return(minValue);
}
double maxValue(double& array[],int shift)
{
   double maxValue = array[shift];
            for (int i=1; i<STCPeriod; i++) maxValue = MathMax(maxValue,array[shift+i]);
   return(maxValue);
}